//-----------------------------------------------------------------------------
// name: server_demo.ck
// author: Dan Trueman, 2007, hacked by PRC Mar. 08 for Wood Piece
//-----------------------------------------------------------------------------

//some global vars
50 => int maxclients; 		//when PLOrk gets really huge, we can change this!
string clients[maxclients];	//for storing client names, as needed
0 => int numclients;		//number of current clients
OscSend xmit[maxclients];	//osc connection to clients
6449 => int port; 			//port for sockets to clients

MAUI_View myWinder;
myWinder.name("Shape Them Woodpeckers!!");
myWinder.size(250.0,500.0);
MAUI_Slider myQ; myQ.range(0.0,30.0);
myQ.name("High Pass Q"); myQ.position(0.0,70.0);
myWinder.addElement(myQ);
MAUI_Slider myFreq; myFreq.range(0.0,1000.0);
myFreq.name("High Pass Freq."); myFreq.position(0.0,140.0);
myWinder.addElement(myFreq);
MAUI_Button die;
die.name("Exit");  die.position(0.0,200);
myWinder.addElement(die);
MAUI_Button fast; fast.name("Slow"); 
fast.toggleType();  fast.position(100.0,200);
myWinder.addElement(fast);
myWinder.display();

2.0 => float myQTarg;
400.0 => float myFreqTarg;
1 => int running;

fun void send_msgs() 
{
    while(running) {
		myQTarg*0.95 + 0.05*myQ.value() => myQTarg;
        if (myFreq.value() < 20.0) 20.0 => myFreq.value;			
		myFreqTarg*0.95 + 0.05*myFreq.value() => myFreqTarg;
        for( 0 => int z; z < numclients; z++ ) {
            // start the message...
            xmit[z].startMsg( "/clockGlobal", "f, f" );
            // a message is kicked as soon as it is complete 
			myQTarg => xmit[z].addFloat;
            myFreqTarg => xmit[z].addFloat;
        }		
	    if (fast.state()==1) 
			fast.name("Slow");
		else
			fast.name("Fast");
        (0.12 + 0.12*(1-fast.state()))::second => now;
    }
}

fun void dieNow()  {
    die => now;
    0 => running;
}
spork ~ dieNow();

2.0 => myQ.value;
400.0 => myFreq.value;

//listen for multicast messages from new clients
spork ~ multicast_receive();

//send messages to clients through direct sockets
spork ~ send_msgs();

//do stuff
while (running) { 1::second => now; }

myWinder.destroy();

/* ********** funcs ************ */

// listens for multicast messages from clients
fun void multicast_receive()
{
    OscRecv recv;	// create our OSC receiver
    5501 => recv.port;
    recv.listen();	// start listening (launch thread)
    recv.event( "/plork/newclient, s" ) @=> OscEvent oe;
    while ( running )    {
        oe => now;	// wait for event to arrive
        while( oe.nextMsg() != 0 )  { // grab next message
            oe.getString() 	=> string newClientName;
            newsocket(newClientName);
        }
    }
}

//check to see if hosttoadd is already
//connected and if not, open up socket 
fun void newsocket(string hosttoadd)
{
	0 => int gotAlready;
	for(0=>int j;j<numclients;j++) {
		if (hosttoadd == clients[j]) {
			1 => gotAlready;
			//<<<"already have host " + hosttoadd>>>;
		}
	}
	if(!gotAlready) {	
		hosttoadd => clients[numclients];  //retain client names if needed
		hosttoadd + ".local" => hosttoadd;
		<<<"adding " + hosttoadd + " as client # " + numclients>>>;
		xmit[numclients].setHost( hosttoadd, port );
		numclients++;	
	}		
}


